﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data;
using DotNetNuke.Framework.Providers;
using DotNetNuke.Common.Utilities;
using SINewsAndArticles.SIUsersCounter.Components;

namespace SINewsAndArticles.SIUsersCounter
{
    public abstract class DataProvider
    {
        private static DataProvider provider;

        public static DataProvider Instance()
        {
            if (provider == null)
            {
                if (provider == null)
                {
                    const string assembly = "SINewsAndArticles.SIUsersCounter.Providers.DataProviders.SqlDataProvider.SqlDataProvider,SINewsAndArticles";
                    Type objectType = Type.GetType(assembly, true, true);

                    provider = (DataProvider)Activator.CreateInstance(objectType);
                    DataCache.SetCache(objectType.FullName, provider);
                }

                return provider;
            }
            return provider;
        }

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1024:UsePropertiesWhereAppropria")]
        public static IDbConnection GetConnection()
        {
            const string providerType = "data";
            ProviderConfiguration _providerConfiguration = ProviderConfiguration.GetProviderConfiguration(providerType);
            Provider objProvider = ((Provider)_providerConfiguration.Providers[_providerConfiguration.DefaultProvider]);
            string _connectionString;
            if (!string.IsNullOrEmpty(objProvider.Attributes["connectionStringName"]) &&
                !String.IsNullOrEmpty(
                    System.Configuration.ConfigurationManager.AppSettings[objProvider.Attributes["connectionString"]]))
            {
                _connectionString =
                    System.Configuration.ConfigurationManager.AppSettings[objProvider.Attributes["connectionString"]];
            }
            else
            {
                _connectionString = objProvider.Attributes["connectionString"];
            }
            IDbConnection newConnection = new System.Data.SqlClient.SqlConnection();
            newConnection.ConnectionString = _connectionString.ToString();
            newConnection.Open();
            return newConnection;
        }
        //Table Users LoginsConfiguration
        public abstract int InsertUsersCounterConfig(SIUsersCounterConfig ucc);
        public abstract int SIDeleteUsersCounterConfig(int Id);
        public abstract int SIUpdateUsersCounterConfig(int Id, SIUsersCounterConfig uss);
        public abstract IDataReader SISelectByIdUsersCounterConfig(int ID);
        public abstract IDataReader SISelectALlIdUsersCounterConfig();
        //Table Users Logins
        public abstract IDataReader SISelectByIdtUsersCounterLogins(int id);
        public abstract int SIInsertUsersCounterLogins(SIUsersCounterLogins ul);
        public abstract int SIDeleteByIdtUsersCounterLogins(int id);
        public abstract IDataReader SISelectBetweenDatesUsersCounterLogins(DateTime BeginDateTime, DateTime EndDateTime);
        public abstract int SISelectBetweenDatesCountUsersCounterLogins(DateTime BeginDateTime, DateTime EndDateTime);
        public abstract IDataReader SISelectByInDateUsersCounterLogins(DateTime InDate);
        public abstract int SISelectByInDateCountUsersCounterLogins(DateTime InDate);
        public abstract int SIUpdatetUsersCounterLogins(int id, SIUsersCounterLogins ul);
        public abstract IDataReader SISelectAllUsersCounterLogins();
        public abstract IDataReader SISelectToDatesUsersCounterLogins(DateTime EndDate);
        public abstract int SISelectToDatesCountUsersCounterLogins(DateTime EndDate);
        public abstract System.Data.IDataReader SISelectBySessionIDCounterLogins(string SessionID);
    }
}