﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.Http;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Web.InternalServices;
using SINewsAndArticles.SIUsersCounter.Components;

namespace SINewsAndArticles.SIUsersCounter
{
    public partial class SIUserCounterSettings : ModuleSettingsBase
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void OnClick(object sender, ImageClickEventArgs e)
        {
            List<SIUsersCounterConfig> tempConfig = SIUsersCounterConfigController.SISelectALlIdUsersCounterConfig();
            if (tempConfig.Count>0)
            {
                SIUsersCounterConfig temp = tempConfig.FirstOrDefault();
                temp.OnlineUsersLabel = ATB_TitleOnlineUsers.Text;
                temp.DailyUsersCounterLabel = ATB_TitleOfTodayUsers.Text;
                temp.fullUsersCounterLable = ATB_TitleOfAllUsers.Text;
                temp.OnlineUsersPic =
                    (FUP_OnlineVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FileID.ToString();
                temp.DailyUsersCounter =
                    (FUP_TodayVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FileID.ToString();
                temp.fullUsersCounter =
                    (FUP_AllVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FileID.ToString();
                SIUsersCounterConfigController.SIUpdateUsersCounterConfig(temp.Id,temp);
            }
            else
            {
                SIUsersCounterConfig temp = new SIUsersCounterConfig();
                temp.OnlineUsersLabel = ATB_TitleOnlineUsers.Text;
                temp.DailyUsersCounterLabel = ATB_TitleOfTodayUsers.Text;
                temp.fullUsersCounterLable = ATB_TitleOfAllUsers.Text;
                temp.OnlineUsersPic =
                    (FUP_OnlineVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FileID.ToString();
                temp.DailyUsersCounter =
                    (FUP_TodayVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FileID.ToString();
                temp.fullUsersCounter =
                    (FUP_AllVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FileID.ToString();
                SIUsersCounterConfigController.InsertUsersCounterConfig(temp);
            }
        }

        protected void loadingTheContent(object sender, EventArgs e)
        {
            var tempToBeLoaded = SIUsersCounterConfigController.SISelectALlIdUsersCounterConfig();
            if (tempToBeLoaded.Count>0)
            {
                ATB_TitleOnlineUsers.Text= tempToBeLoaded.FirstOrDefault().OnlineUsersLabel;
                ATB_TitleOfTodayUsers.Text = tempToBeLoaded.FirstOrDefault().DailyUsersCounterLabel;
                ATB_TitleOfAllUsers.Text = tempToBeLoaded.FirstOrDefault().fullUsersCounterLable;
                if (tempToBeLoaded.FirstOrDefault().OnlineUsersPic!="0")
                {
                    (FUP_OnlineVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FilePath =
                        FileUploadController.GetUrl(Convert.ToInt32(tempToBeLoaded.FirstOrDefault().OnlineUsersPic));
                }
                if (tempToBeLoaded.FirstOrDefault().DailyUsersCounter!="0")
                {
                    (FUP_TodayVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FilePath =
                        FileUploadController.GetUrl(Convert.ToInt32(tempToBeLoaded.FirstOrDefault().DailyUsersCounter)); 
                }

                if (tempToBeLoaded.FirstOrDefault().fullUsersCounter != "0")
                {
                    (FUP_AllVisitsPic as DotNetNuke.Web.UI.WebControls.DnnFilePickerUploader).FilePath =
                        FileUploadController.GetUrl(Convert.ToInt32(tempToBeLoaded.FirstOrDefault().fullUsersCounter));
                }
            }
        }
    }
}