﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using DotNetNuke.Entities.Modules;
using DotNetNuke.Entities.Users;
using DotNetNuke.UI.UserControls;
using SINewsAndArticles.SIUsersCounter.Components;
using DotNetNuke.Web.InternalServices;

namespace SINewsAndArticles.SIUsersCounter
{
    public partial class SIUsersCounterView :PortalModuleBase
    {
        private int _dailUsersCount;
        private int _fullUsersOnlined;
        private int _countOfOnlineUsers;
        private string _onlineUserLabel;
        private string _dailyOnlineUsers;
        private string _fullOnlineIsers;
        private string _onlineUserLabelPic;
        private string _dailyOnlineUsersPic;
        private string _fullOnlineIsersPic;

        public int CountOfOnlineUsers
        {
            get { return _countOfOnlineUsers; }
            set { _countOfOnlineUsers = value; }
        }

        public int FullUsersOnlined
        {
            get { return _fullUsersOnlined; }
            set { _fullUsersOnlined = value; }
        }

        public string OnlineUserLabel
        {
            get { return _onlineUserLabel; }
            set { _onlineUserLabel = value; }
        }

        public string DailyOnlineUsers
        {
            get { return _dailyOnlineUsers; }
            set { _dailyOnlineUsers = value; }
        }

        public string FullOnlineIsers
        {
            get { return _fullOnlineIsers; }
            set { _fullOnlineIsers = value; }
        }

        public string OnlineUserLabelPic
        {
            get { return _onlineUserLabelPic; }
            set { _onlineUserLabelPic = value; }
        }

        public string DailyOnlineUsersPic
        {
            get { return _dailyOnlineUsersPic; }
            set { _dailyOnlineUsersPic = value; }
        }

        public string FullOnlineIsersPic
        {
            get { return _fullOnlineIsersPic; }
            set { _fullOnlineIsersPic = value; }
        }

        public int DailUsersCount
        {
            get { return _dailUsersCount; }
            set { _dailUsersCount = value; }
        }

        protected void Page_Load(object sender, EventArgs e)
        {

        }

        protected void MainContainerOnLoad(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                SIUsersCounterConfig tempConfig =
                    SIUsersCounterConfigController.SISelectALlIdUsersCounterConfig().FirstOrDefault();
                if (tempConfig==null)
                {
                    tempConfig=new SIUsersCounterConfig();
                }
                if (tempConfig!=null)
                {
                    if (tempConfig.DailyUsersCounter == "0" || string.IsNullOrEmpty(tempConfig.DailyUsersCounter))
                    {
                        AIM_DailyOnlineUsers.ImageUrl = "images/Calendar Search.png";
                    }
                    else
                    {
                        AIM_DailyOnlineUsers.ImageUrl = FileUploadController.GetUrl(Convert.ToInt32(tempConfig.DailyUsersCounter));
                    }
                    if (String.IsNullOrEmpty(tempConfig.OnlineUsersLabel))
                    {
                        ALB_OnlineUserCounterLabel.Text = "کاربران آنلاین";
                    }
                    else
                    {
                        ALB_OnlineUserCounterLabel.Text = tempConfig.DailyUsersCounterLabel;
                    }
                    if (String.IsNullOrEmpty(tempConfig.fullUsersCounterLable))
                    {
                        ALB_FullOnlineUsersLa.Text = "کلیه بازدیدها";
                    }
                    else
                    {
                        ALB_FullOnlineUsersLa.Text = tempConfig.fullUsersCounterLable;
                    }
                    if (String.IsNullOrEmpty(tempConfig.DailyUsersCounterLabel))
                    {
                        ALB_DailyOnlineUsersLa.Text = "کابران امروز";
                    }
                    else
                    {
                        ALB_DailyOnlineUsersLa.Text = tempConfig.DailyUsersCounterLabel;
                    }
                    if (tempConfig.OnlineUsersPic == "0" || string.IsNullOrEmpty(tempConfig.OnlineUsersPic))
                    {
                        AIMA_OnlineUsersCounter.ImageUrl = "images/online22.png";
                    }
                    else
                    {
                        AIMA_OnlineUsersCounter.ImageUrl = FileUploadController.GetUrl(Convert.ToInt32(tempConfig.OnlineUsersPic));
                    }
                    if (tempConfig.DailyUsersCounterLabel == "0" || string.IsNullOrEmpty(tempConfig.DailyUsersCounterLabel))
                    {
                        AIM_fullOnlineUsers.ImageUrl = "images/Calendar Refresh.png";
                    }
                    else
                    {
                        AIM_fullOnlineUsers.ImageUrl = FileUploadController.GetUrl(Convert.ToInt32(tempConfig.fullUsersCounter));
                    }
                    if (string.IsNullOrEmpty(tempConfig.OnlineUsersPic))
                    {
                        
                    }
                }
            }
            
            if (Session["SIUserCounterControl"]==null)
            {
                SIUsersCounterLogins tempUserCounterLogin = new SIUsersCounterLogins();
                tempUserCounterLogin.SessionID = Session.SessionID;
                tempUserCounterLogin.UserId = UserId;
                tempUserCounterLogin.GoOutDateTime = DateTime.Now;
                tempUserCounterLogin.ComeInDateTime = DateTime.Now;
                SIUsersCounterLoginsController.SIInsertUsersCounterLogins(tempUserCounterLogin);
                Session["SIUserCounterControl"] = tempUserCounterLogin;
            }
            else
            {
                var tempList=SIUsersCounterLoginsController.SISelectBySessionIDCounterLogins(Session.SessionID);
                if (tempList.Count>0)
                {
                    tempList.FirstOrDefault().ComeInDateTime = DateTime.Now;
                    tempList.FirstOrDefault().UserId = UserId;
                    SIUsersCounterLoginsController.SIUpdatetUsersCounterLogins(tempList.FirstOrDefault().Id, tempList.FirstOrDefault());
                }
            }
            DateTime temp = DateTime.Now;
            temp = temp.AddMinutes(-10);
            var listOfOnlineUsers = SIUsersCounterLoginsController.SISelectBetweenDatesUsersCounterLogins(temp,
                DateTime.Now);
            ALB_OnlineUsersCounter.Text = listOfOnlineUsers.Count.ToString();
            temp = temp.AddDays(-1);
            listOfOnlineUsers = SIUsersCounterLoginsController.SISelectBetweenDatesUsersCounterLogins(temp,
                DateTime.Now);
            ALB_DailOnlineUsersCounter.Text = listOfOnlineUsers.Count.ToString();
            listOfOnlineUsers = SIUsersCounterLoginsController.SISelectToDatesUsersCounterLogins(DateTime.Now);
            LaALB_FullOnlineUsersCounter.Text = listOfOnlineUsers.Count.ToString();
        }

        public string GetUserImageUrl(string UserIdinp)
        {
            int intUserId = Convert.ToInt32(UserIdinp);
            if (intUserId < 1)
            {
                return "images/stock_people.png";
            }
            else if (string.IsNullOrEmpty(UserController.GetUserById(PortalId,intUserId).Profile.PhotoURL))
            {
                return "images/stock_people.png";
            }
            else
            {
                return UserController.GetUserById(PortalId, intUserId).Profile.PhotoURL;
            }
        }

        public void showTHeIntroductions(object sender, ImageClickEventArgs e)
        {
            Response.Redirect(EditUrl());
        }
        protected void goToIndexOfListOfUsers(object sender, ImageClickEventArgs e)
        {
            var listOfOnlineUsers = SIUsersCounterLoginsController.SISelectBetweenDatesUsersCounterLogins((DateTime.Now.AddMinutes(-10)),
                   DateTime.Now);
            ARE_ListOfOnlineUsers.DataSource = listOfOnlineUsers;
            ARE_ListOfOnlineUsers.DataBind();
            AMV_userCounter.ActiveViewIndex = 1;
        }

        protected void gotoAmarPage(object sender, ImageClickEventArgs e)
        {
            AMV_userCounter.ActiveViewIndex = 0;
        }

        public string userName(string UserIdd)
        {
            int UserIdint = Convert.ToInt32(UserIdd);
            if (UserIdint<1)
            {
                return "ناشناس";
            }else if (!string.IsNullOrEmpty(UserController.GetUserById(PortalId,UserIdint).DisplayName))
            {
                return UserController.GetUserById(PortalId, UserIdint).DisplayName;
            }
            return "ناشناس";
        }
    }
}